﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;
using System.Reflection;
using System.IO;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.AppStyling;

namespace MemDataTable_CS
{
    public partial class Form1 : Form
    {
        private DataTable dt1;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Set grid's DataSource
            dt1 = DummyDataCreator.GetData(10, new Type[] { typeof(decimal), typeof(int) });

            dt1.TableName = "Band 0";
                        
            foreach (DataRow row in dt1.Rows)
            {
                row["Int32 1"] = DummyDataCreator.RandomInt(5000, 5010);
                row["Decimal 1"] = Math.Round(((decimal)row["Decimal 1"]), 0);
            }
            dt1.AcceptChanges();

            this.ultraGrid1.DataSource = dt1;

            this.ultraGridExcelExporter1.InitializeColumn += this.UltraGridExcelExporter1_InitializeColumn;
            this.ultraGridExcelExporter1.ExportValueLists = false;
        }

        private void UltraGridExcelExporter1_InitializeColumn(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.InitializeColumnEventArgs e)
        {
            if (e.Column.DataType == typeof(decimal))
                e.ExcelFormatStr = "#,#0.00";
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];
            var ov = layout.Override;

            band.Columns["Decimal 1"].Format = "#,#0.00";
            var vl = new ValueList();
            for (int i = 5000; i < 5011; i++)
                vl.ValueListItems.Add(i);
            band.Columns["Int32 1"].ValueList = vl;
        }

        private void btnExport_Click(object sender, EventArgs e)
        {
            var filename = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "x.xlsx");
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, filename);
            Process.Start(filename);
        }
    }
}

